require 'uri'

Puppet::Functions.create_function(:'foreman_proxy_content::parse_uri') do
  dispatch :parse do
    param 'Stdlib::Httpurl', :uri
  end

  def parse(uri)
    parsed = URI(uri)
    {
      'scheme' => parsed.scheme,
      'host' => parsed.host,
      'path' => parsed.path,
      'query' => parsed.query,
      'fragment' => parsed.fragment,
    }
  end
end
